package prob0361;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 * Chapter 3, Problem 61 from <i>Computer Systems</i>.
 *
 * <p>
 * File: <code>Prob0361.java</code>
 *
 * <p>
 * Name:
 *
 * <p>
 * Date:
 *
 * <p>
 * Assignment:
 */
public class Prob0361Main implements ActionListener {

    final JFrame mainWindowFrame;
    final JPanel inputPanel;
    final JLabel label;
    final JTextField textField;
    final JPanel buttonPanel;
    final JButton button;

    public Prob0361Main() {
        //Set up the main window.
        mainWindowFrame = new JFrame("Problem 3.61");
        mainWindowFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mainWindowFrame.setSize(new Dimension(240, 120));

        //Lay out the label and text field input panel from top to bottom.
        inputPanel = new JPanel();
        inputPanel.setLayout(new BoxLayout(inputPanel, BoxLayout.PAGE_AXIS));
        label = new JLabel("Enter an eight-bit binary number:");
        inputPanel.add(label);
        textField = new JTextField(20);
        inputPanel.add(textField);
        inputPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

        //Lay out the button from left to right.
        buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
        buttonPanel.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel.add(Box.createHorizontalGlue());
        button = new JButton("Convert to decimal");
        buttonPanel.add(button);
        buttonPanel.add(Box.createRigidArea(new Dimension(10, 0)));

        //Combine the input panel and the button panel in the main window.
        mainWindowFrame.add(inputPanel, BorderLayout.CENTER);
        mainWindowFrame.add(buttonPanel, BorderLayout.PAGE_END);

        textField.addActionListener(this);
        button.addActionListener(this);

        mainWindowFrame.pack();
        mainWindowFrame.setVisible(true);
    }

    private static void createAndShowGUI() {
        JFrame.setDefaultLookAndFeelDecorated(true);
        new Prob0361Main();
    }

    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(Prob0361Main::createAndShowGUI);
    }

    @Override
    public void actionPerformed(ActionEvent event) {
        int[] binNum = new int[8];
        String line = textField.getText();
        if (line.length() != 8) {
            System.out.print("Enter exactly eight bits.\n");
            return;
        }
        for (int i = 0; i < 8; i++) {
            binNum[i] = line.charAt(i) - '0';
            if (binNum[i] != 0 && binNum[i] != 1) {
                System.out.print("Each character must be 0 or 1.\n");
                return;
            }
        }
        // Problem for the student
        // Remove the following code and output signed decimal number here.
        binNum[0] = 1;
        System.out.printf("%d \n", binNum[0]);
    }
}
